import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class HttpServer02  {	
	
	private int port=0;
	
	public HttpServer02(int port,Observer guiObserver) throws IOException{
		
		//this.guiObserver=guiObserver;
		this.port=port;
		//httpRequestHandler hrh=null;
		ServerSocket server_socket = new ServerSocket(this.port);
		System.out.println("httpServer running on port " +server_socket.getLocalPort());
		while(true) {
	        	Socket sk = server_socket.accept();
	        	System.out.println("New connection accepted " +sk.getInetAddress() +":" + sk.getPort());
	
		       	try {
		       		httpRequestHandler request =new httpRequestHandler(sk,guiObserver);
				Thread td = new Thread(request);
				td.start();
			}
		        catch(Exception e) {
		            	System.out.println(e);
		        }
	       	} 
	}
	public static void main(String args[]) {
  		ServerGui02 serverFrame=new ServerGui02();
  		
		serverFrame.setSize(400,200); // pack will override
		serverFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		serverFrame.setVisible(true);
		serverFrame.pack();
  		try{
			new HttpServer02(8080,serverFrame);		
		}
		catch(IOException e){
		}
	} 
} 



class httpRequestHandler extends Observable implements Runnable {
	    final static String CRLF = "\r\n";
	    Socket socket;
	    InputStream input;
	    OutputStream output;
	    BufferedReader br;
	    FileInputStream fis=null;
	    private Observer obs=null;
	    private String str_rHead="Request Header|";
	    private String str_rPayload="Request Payload|";
	    private String str_rsHead="Response Header|";
	    private String str_rsPayload="Response Payload|";
	    
    
   // Constructor
   public httpRequestHandler(Socket sk,Observer obs) throws Exception {
   	    this.addObserver(obs);
	    this.socket = sk;
	    this.input = sk.getInputStream();
	    this.output = sk.getOutputStream();
	    this.br =
	        new BufferedReader(new InputStreamReader(sk.getInputStream()));
   }

    // Implement the run() method of the Runnable interface.
    public void run() {

	     try {
	         processRequest();
	         
	     }
	     catch(Exception e) {
	        System.out.println(e);
	     }
    }

    private void processRequest() throws Exception {

        // create new Request and Response objects
        // based on the RequestImpl and ResponseImpl classes that you write
        Request request = new RequestImpl();
       

        // read first (command line): print and pass to Request object
        String cmdLine = br.readLine();
        System.out.println(cmdLine);
        request.setCommand(cmdLine);        
	setChanged();
	notifyObservers(cmdLine);

      // loop over Header Key: value pairs until blank line
      // indicating end of header

      while(true) {

        String headerLine = br.readLine();
        System.out.println(headerLine);
	str_rHead=str_rHead+headerLine+CRLF;
        // see if we are at end of headers
        if(headerLine.equals(CRLF) || headerLine.equals("")) break;

        // if we have a header, add it to Request object
        request.setHeaderKeyValue(headerLine);
        
     }
     setChanged();
     notifyObservers(str_rHead);
    

     // When we come out of the above loop we have processed entire header.
     // Check now to see if there is any payload after the blank line
     // by checking the content-length header value

     // The Request object must work correctly and return int length
      
     int contentLength = request.getContentLength();
	System.out.println(" "+contentLength);
     // If content-length is indicated, read in all the payload bytes

     if ( contentLength > 0) {
         byte [] payload = new byte[contentLength];
	 
	 fis=new FileInputStream (request.getFileName());
         // read in the bytes from the client stream
         try {
	       	fis.read(payload);
	 }
         catch(FileNotFoundException e) {
	       		System.out.println("The files is not open successfully!");
	 }
         
         System.out.println("------------");
         request.setPayload(payload);
         
         System.out.println(request.getPayloadAsString() );
        
     }
     str_rPayload=str_rPayload+request.getPayloadAsString();
     setChanged();
     notifyObservers(str_rPayload);

	/**********************************************************/

     // The request object should now "know" everything about the
     // incoming client request, including the command (GET or POST).
     // If GET, call doGet which is responsible for filling the
     // Response object with everything it needs for a reply to the client
	Response response = new ResponseImpl(RequestImpl.headers);
     if (request.getCommandURI().equals("GET")) {
         doGet(request, response);
     }
     else if (request.getCommandURI().equals("POST")){
     	str_rPayload=str_rPayload+"POST received";
	setChanged();
        notifyObservers(str_rPayload);
     }     	
     
     else {
         System.out.println("DEBUG 1");
         doError(request, response);
     }


     // With the response object loaded with everything it needs,
     // the handler now sends its reply back to the client
	
     String replyLine = response.getReplyLine();
     output.write(replyLine.getBytes());

     // get and disply header info
     String [] headerLineArray = response.getHeaders();
     for(int i=0; i< headerLineArray.length; i++) {
     	str_rsHead=str_rsHead+headerLineArray[i];
         output.write(headerLineArray[i].getBytes() );
         
     }
     setChanged();
     notifyObservers(str_rsHead);

     // write blank line
     output.write(CRLF.getBytes() );

     // if payload, write it
     byte [] respPayload = response.getPayload();
     if (respPayload.length > 0) {
         output.write(respPayload);
     }
     str_rsPayload=str_rsPayload+response.getPayloadAsString();
     setChanged();
     notifyObservers(str_rsPayload);

    try {
        output.close();
        br.close();
        socket.close();
    }
    catch(Exception e) {}

    } // end method


// rewrite this method to load the requested file
// if available into the payload and set header
// values where appropriate

public void doGet(Request req, Response resp) {
    System.out.println("in doGet");

    resp.setReplyLine("HTTP/1.1 200 OK");//DP
    System.out.println(resp.getReplyLine());//by DP
    

    String payload =req.getPayloadAsString();

    resp.setHeader("content-length: " + payload.length());
    resp.setPayload(payload.getBytes() );
}

// called if an illegal HTTP command was found
// modify as needed

public void doError(Request req, Response resp) {
        System.out.println("in doError");

        resp.setReplyLine("HTTP/1.0 404 File not Found");

        String payload = "<h1>Hey Folks -- AN Error </h1>";

        resp.setHeader("content-length: " + payload.length() );
        resp.setPayload(payload.getBytes() );

}



} // end handler class









