import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import java.lang.String;


public class ServerGui02 extends JFrame implements Observer{
   final static String CRLF = "\r\n";
  private JLabel jlbl =new JLabel("ServerGUI - Buttons have ActionListeners",JLabel.CENTER);

  private JTextArea reqHeader  = new JTextArea("RequestHeader info", 6, 25 );
  private JTextArea reqPayload = new JTextArea("RequestPayload info", 6, 25 );
  private JTextArea respHeader    = new JTextArea("ResponseHeader info", 10, 25);
  private JTextArea respPayload   = new JTextArea("ResponsePayload info", 10, 25);


  private JPanel centerPanel   = new JPanel();
  private JPanel eastPanel     = new JPanel();
  private JPanel westPanel     = new JPanel();
  private JPanel northPanel    = new JPanel();
  private JPanel southPanel    = new JPanel();

  private JButton jbt1   = new JButton("B1");
  private JButton jbt2   = new JButton("B2");
  private JButton jbt3   = new JButton("B3");

  // Decorate JTextAreas with JScrollPanes
  // we then add the JScrollPane to the GUI
  private JScrollPane scroll1 = new JScrollPane(reqHeader);
  private JScrollPane scroll2 = new JScrollPane(respHeader);
  private JScrollPane scroll3 = new JScrollPane(reqPayload);
  private JScrollPane scroll4 = new JScrollPane(respPayload);

  // Set up some CheckBoxes
  JCheckBox xmlBox = new JCheckBox("XML");
  JCheckBox wellFormedBox = new JCheckBox("WellFormed");
  JCheckBox validBox = new JCheckBox("Valid");





	public ServerGui02() {
	    setTitle("ServerGUI");
	
	    // Set background color for the major panels
	    centerPanel.setBackground(Color.red);
	    eastPanel.setBackground(Color.green);
	    westPanel.setBackground(Color.blue);
	    northPanel.setBackground(Color.yellow);
	    southPanel.setBackground(Color.magenta);
	
	
	    // Define Layout Manager object
	    BorderLayout myLayout = new BorderLayout();
	
	    // Assign layout manager to Top Level Panel
	    this.getContentPane().setLayout(myLayout);
	
	
	    // Add Panels to Top Level panel of the frame
	
	    getContentPane().add(centerPanel, BorderLayout.CENTER);
	    getContentPane().add(eastPanel,   BorderLayout.EAST);
	
	    getContentPane().add(westPanel,   BorderLayout.WEST);
	    getContentPane().add(northPanel,  BorderLayout.NORTH);
	    getContentPane().add(southPanel,  BorderLayout.SOUTH);
	
	    //add buttons to eastPanel
	    eastPanel.add(jbt1);
	    eastPanel.add(jbt2);
	
	    // change layout of eastPanel - Grid with 5 rows & 1 column
	    eastPanel.setLayout(new GridLayout(5,1));
	
	    //add JLabel to the north
	    northPanel.add(jlbl);
	
	    // add textfields to the center panel
	    centerPanel.add(scroll1);
	    centerPanel.add(scroll2);
	    centerPanel.add(scroll3);
	    centerPanel.add(scroll4);
	
	    // set layout so textfields line up vertically
	    // 3 rows and 1 column
	    centerPanel.setLayout(new GridLayout(3,1,5,5));
	
	    // add CheckBoxes to the  south
	    southPanel.add(xmlBox);
	    southPanel.add(wellFormedBox);
	    southPanel.add(validBox);
	
	
	
	    //SPECIFY EVENT HANDLERS for Button Presses
	    // - A Button Press generates an ActionEvent which is
	    //  passed to an event handler -- For buttons
	    //  the object handler must implement the ActionListener
	    //  interface which has one method: ActionPerformed
	
	    // add ANONYMOUS INNER CLASS as ActionListener
	      jbt1.addActionListener(new ActionListener()
	       {
	          public void actionPerformed(ActionEvent e) {
	             xmlBox.setSelected(true);
	             wellFormedBox.setSelected(true);
	             validBox.setSelected(false);
	          }
	        }
	      );
	
	    // add ANONYMOUS INNER CLASS as ActionListener
	      jbt2.addActionListener(new ActionListener()
	       {
	          public void actionPerformed(ActionEvent e) {
	              String s = reqHeader.getText();
	              reqPayload.setText(s);
	
	
	          }
	        }
	      );
	
	          // add ANONYMOUS INNER CLASS as ActionListener
	      jbt3.addActionListener(new ActionListener()
	       {
	          public void actionPerformed(ActionEvent e) {
	
	          }
	        }
	      );
	
	  } // end constructor

	/*
	  public static void main(String[] args) {
	    ServerGui02 frame = new ServerGui02();
	    frame.setSize(400,200); // pack will override
	    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	    frame.setVisible(true);
	    frame.pack();
	  }
	  */
	  
	 public void update(Observable o,Object arg){
		String s=(String)arg;	
		StringTokenizer st=new StringTokenizer (s,"|");
		String st_1=st.nextToken();	
		
		if("Request Header|".equals(s.substring(0,15))){
			reqHeader.setText(st.nextToken());
			
		}
		else if("Request Payload|".equals(s.substring(0,16))){
			reqPayload.setText(st.nextToken());
		}
		else if("Response Header|".equals(s.substring(0,16))){
			respHeader.setText(st.nextToken());
		}
		else if("Response Payload|".equals(s.substring(0,17))){
			respPayload.setText(st.nextToken());
		}	
		else if ("POST".equals(s.substring(0,4))){
			reqPayload.setText("Received: "+s);
		}			
	 }
}